
Foreman - Bug #3194

Ugly errors when destroy actions are stopped by FKs

10/03/2013 03:23 PM - Dominic Cleal

Status: Duplicate   

Priority: Normal   

Assignee:    

Category: Database   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Server errors aren't very helpful when an FK prevents a destroy:

PG::ForeignKeyViolation: ERROR:  update or delete on table "smart_proxies" violates foreign key co

nstraint "subnets_dhcp_id_fk" on table "subnets" 

DETAIL:  Key (id)=(1) is still referenced from table "subnets".

: DELETE FROM "smart_proxies" WHERE "smart_proxies"."id" = $1

   (145.2ms)  ROLLBACK

Completed 500 Internal Server Error in 3385ms

Related issues:

Related to Foreman - Feature #2400: Add foreign keys on database level Closed 04/15/2013

Related to Hammer CLI - Bug #4033: Need a clearer / user friendly message whe... Duplicate 01/16/2014

Related to Foreman - Bug #4415: FK error when deleting a smart proxy Duplicate 02/23/2014

Is duplicate of Foreman - Bug #5788: before_destroy missing from EnsureNotUse... Closed 05/19/2014

History

#1 - 10/04/2013 03:17 PM - Dominic Cleal

- Related to Feature #2400: Add foreign keys on database level added

#2 - 11/26/2013 11:17 AM - Dominic Cleal

And equally ugly in MySQL..    

Mysql2::Error: Cannot delete or update a parent row: a foreign key constraint fails (`puppet`.`hostgroups`, CO

NSTRAINT `hostgroups_puppet_ca_proxy_id_fk` FOREIGN KEY (`puppet_ca_proxy_id`) REFERENCES `smart_proxies` (`id

`)): DELETE FROM `smart_proxies` WHERE `smart_proxies`.`id` = 4

#3 - 01/16/2014 04:34 PM - Dominic Cleal

- Related to Bug #4033: Need a clearer / user friendly message when deletion of smart proxy fails added

#4 - 02/24/2014 08:43 AM - Dominic Cleal

- Related to Bug #4415: FK error when deleting a smart proxy added

#5 - 05/23/2014 10:06 AM - Dominic Cleal

- Is duplicate of Bug #5788: before_destroy missing from EnsureNotUsedBy.new in SmartProxy model added

#6 - 05/23/2014 10:06 AM - Dominic Cleal

- Status changed from New to Duplicate

We had a helper whose job it was to provide friendly messages, but it wasn't invoked correctly.  #5788 has fixed this.

#7 - 06/13/2014 04:03 PM - Dominic Cleal
https://projects.theforeman.org/issues/5788


- Bugzilla link set to https://bugzilla.redhat.com/show_bug.cgi?id=1109315

#8 - 06/13/2014 04:06 PM - Dominic Cleal

- Bugzilla link deleted (https://bugzilla.redhat.com/show_bug.cgi?id=1109315)
